---
title: AudioContext.createMediaStreamTrackSource()
slug: Web/API/AudioContext/createMediaStreamTrackSource
tags:
  - API
  - Audio
  - AudioContext
  - MediaStreamTrack
  - MediaStreamTrackAudioSource
  - Method
  - Node
  - Reference
  - Web Audio API
  - createMediaStreamTrackSource
  - sound
  - source
  - track
---
<p>{{draft}}{{ APIRef("Web Audio API") }}</p>

<div>
<p>The <strong><code>createMediaStreamTrackSource()</code></strong> method of the {{ domxref("AudioContext") }} interface creates and returns a {{domxref("MediaStreamTrackAudioSourceNode")}} which represents an audio source whose data comes from the specified {{domxref("MediaStreamTrack")}}.</p>

<p>This differs from {{domxref("AudioContext.createMediaStreamSource", "createMediaStreamSource()")}}, which creates a {{domxref("MediaStreamAudioSourceNode")}} whose audio comes from the audio track in a specified {{domxref("MediaStream")}} whose {{domxref("MediaStreamTrack.id", "id")}} is first, lexicographically (alphabetically).</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>audioCtx</em> = new AudioContext();
var <em>track</em> = <em>audioCtx</em>.createMediaStreamTrackSource(<em>track</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>track</code></dt>
 <dd>The {{domxref("MediaStreamTrack")}} to use as the source of all audio data for the new node.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("MediaStreamTrackAudioSourceNode")}} object which acts as a source for audio data found in the specified audio track.</p>

<h2 id="Example">Example</h2>

<p>In this example, {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}} is used to request access to the user's microphone. Once that access is attained, an audio context is established and a {{domxref("MediaStreamTrackAudioSourceNode")}} is created using <code>createMediaStreamTrackSource()</code>, taking its audio from the first audio track in the stream returned by <code>getUserMedia()</code>.</p>

<p>Then a {{domxref("BiquadFilterNode")}} is created using {{domxref("AudioContext.createBiquadFilter", "createBiquadFilter()")}}, and it's configured as desired to perform a lowshelf filter on the audio coming from the source. The output from the microphone is then routed into the new biquad filter, and the filter's output is in turn routed to the audio context's {{domxref("AudioContext.destination", "destination")}}.</p>

<pre class="brush: js">navigator.mediaDevices.getUserMedia ({audio: true, video: false})
.then(function(stream) {
  audio.srcObject = stream;
  audio.onloadedmetadata = function(e) {
    audio.play();
    audio.muted = true;
  };

  let audioCtx = new AudioContext();
  let source = audioCtx.createMediaStreamSource(stream);

  let biquadFilter = audioCtx.createBiquadFilter();
  biquadFilter.type = "lowshelf";
  biquadFilter.frequency.value = 3000;
  biquadFilter.gain.value = 20;

  source.connect(biquadFilter);
  biquadFilter.connect(audioCtx.destination);
})
.catch(function(err) {
  // Handle getUserMedia() error
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audiocontext-createmediastreamtracksource', 'createMediaStreamTrackSource()')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioContext.createMediaStreamTrackSource")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>Web Audio API</li>
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
 <li>{{domxref("MediaStreamTrackAudioSource")}}</li>
</ul>
